import("./utils.js").then((utils) => {
    import(utils.coreVersion()).then((core) => {

        customElements.define(
            "solid-tzcld",
            class extends core.SolidTemplateElement {
              constructor() {
                super();
                this.setTranslationsPath(`${utils.path()}/locales`);
                utils.setupOrbit(this);
              }
      
              static get propsDefinition() {
                return {
                  //uniqCommunity: "uniq-community",
                  parts: "parts",
                  partsPoints: "parts-points",
                  pointAnswers: "point-answers",
                  followParts: "follow-parts",
                  followPartsPoints: "follow-parts-points",
                  followPointAnswers: "follow-point-answers",
                  communities: "communities",
                  myCommunities: "my-communities",
                  territoriesTrainingCourses: "training-courses",
                  territoriesTrainingPromotions: "training-promotions",
                  regions: "regions",
                  kinds: "kinds",
                  territoriesStepStates: "territories-step-states",
                  territoriesOriginsMobilisation: "territories-origins-mobilisation",
                  apiUrl: "api-url",
                };
              }
      
              routeurs() {
                let render = `
                <solid-router default-route="${utils.TZCLD_URLS.my_territories}" route-prefix="tzcld">
                  <solid-route name="${utils.TZCLD_URLS.my_territory_space}"></solid-route>
                  <solid-route name="${utils.TZCLD_URLS.my_territories}"></solid-route>
                  <solid-route name="${utils.TZCLD_URLS.my_territory_infos}" use-id></solid-route>
                  <solid-route name="${utils.TZCLD_URLS.my_territory_auto_eval}" use-id></solid-route>
                </solid-router>
                `;
      
                return render;
              }
      
              viewWidgets() {
                let render = `
                
                
      
                <solid-widget name="tzcld-communities-counter-alternate">
                  <template>
                    <div>
                      <span class="icon icon-people icon-third icon-large margin-right-xsmall"></span>
                      <solid-display
                        fields=""
                        data-src="\${src || value}"
                        nested-field="members"
                        counter-template="\\\${counter}">
                      </solid-display>
                      <span>${this.localize("list.members")}</span>
                    </div>
                  </template>
                </solid-widget>
      
                <solid-widget name='tzcld-communities-name'>
                  <template>
                    <solid-link
                      data-src="\${value}"
                      next="${this.route}-community-profile">
                      \${await value.name}
                    </solid-link>
                  </template>
                </solid-widget>
      
                <solid-widget name='tzcld-communities-profile-members-counter'>
                  <template>
                    <span>
                      <span class="margin-bottom-xsmall icon mdi-account-multiple icon-third icon-large icon-margin-right-xsmall"></span>
                      <solid-display
                        class="text-medium"
                        data-src="\${src || value}"
                        fields=''
                        counter-template="\\\${counter}"
                      ></solid-display>
                      <span class="text-medium">${this.localize("profile.members")}</span>
                    </span>
                  </template>
                </solid-widget>
      
                <solid-widget name="tzcld-communities-profile-twitter">
                  <template>
                    \${value != "" ? \`<a class="segment children-link-rounded children-icon-social-twitter children-link-reversed color-secondary bordered margin-right-medium" href="\${value}" target="_blank"><span></span></a>\` : ""}
                  </template>
                </solid-widget>
      
                <solid-widget name="tzcld-communities-profile-website">
                  <template>
                    \${value != "" ? \`<a class="link margin-bottom-xsmall icon mdi-link-variant icon-third icon-large icon-margin-right-xsmall link-hover" href="\${value}" target="_blank">\${value}</a>\` : ""}
                  </template>
                </solid-widget>
      
                <solid-widget name="tzcld-communities-profile-picture">
                  <template>
                    \${value != "" ? \`<div><div style="background-image:url(\${value});"></div></div>\` : \`<div class="picture-empty"></div>\`}
                  </template>
                </solid-widget>
      
                <solid-widget name="tzcld-communities-profile-phone">
                  <template>
                    \${value != "" ? \`<a class="link margin-bottom-xsmall icon mdi-cellphone-iphone icon-third icon-large icon-margin-right-xsmall link-hover" href="tel:\${value}">\${value}</a>\` : ""}
                  </template>
                </solid-widget>
      
                <solid-widget name="tzcld-communities-profile-logo">
                  <template>
                    \${value != "" ? \`<div style="background-image:url(\${value});" />\` : ""}
                  </template>
                </solid-widget>
                
                `;
                return render;
              }
      
              viewMyCommunity() {
                let render = `
                    <div class="segment block margin-right-xxsmall margin-left-xxsmall sm-margin-none padding-top-none sm-padding-xsmall whitespace-normal">
                      <div class="loader" id="loader-${this.route}-my-community">
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                      </div>
                      <solid-display 
                      class="segment block whitespace-normal" fields="edit, tzcld_profile.community" 
                      loader-id="loader-${this.route}-my-community" 
                      action-edit="edit" 
                      widget-edit="communities-edit-button-${utils.community_uniq()}" 
                      bind-resources="" 
                      class-edit="segment block text-right" 
                      widget-tzcld_profile.community="customtzcld-display-territory-profile-widget" 
                      solid-resource=""
                      `;
      
                  render += `>
                      </solid-display>`;
                  
      
                render += `
                  </div>`;
                  
                return render;
              }
              viewMyCommunities() {
                let render = `
                  <div id="${utils.TZCLD_URLS.my_territories}" data-view="${utils.TZCLD_URLS.my_territories}" class="tzcld-my-communities">
      
                    <div class="segment block margin-right-xxsmall margin-left-xxsmall sm-margin-none padding-top-xlarge sm-padding-xsmall whitespace-normal">
                    <h2 class="margin-top-xxsmall margin-left-xsmall margin-bottom-medium sm-margin-none sm-margin-right-xsmall sm-margin-bottom-small sm-margin-left-xsmall text-xlarge text-bold text-color-heading text-uppercase">Mes territoires</h2>
                      <div class="loader" id="loader-${this.route}-my-communities">
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                      </div>
                      <solid-form-search 
                      class="form search-form sm-whitespace-normal" 
                      id="my-communities-filter" 
                      fields="name, segment1(tzcld_profile.regions, tzcld_profile.kind, tzcld_profile.step_state)" 
                      class-name="segment margin-bottom-small full sm-full padding-right-xsmall padding-left-xsmall sm-padding-none input-shadow input-bg-white icon icon-magnify text-xlarge text-semibold text-color-heading" 
                      submit-button="Rechercher" 
                      submit-widget="button" 
                      class-submit-button="search-button segment sm-full text-xsmall children-link-button children-link-text-bold children-link-text-uppercase children-link-color-secondary bordered children-button-icon children-icon-arrow-right-circle children-icon-small children-icon-margin-right-xsmall text-right block padding-right-xsmall padding-left-xsmall " 
                      class-segment1="segment full padding-right-xsmall padding-left-xsmall rowClear" 
                      range-tzcld_profile.regions="${this.regions}" 
                      widget-tzcld_profile.regions="solid-form-multipleselect-autocompletion-label" 
                      class-tzcld_profile.regions="segment margin-bottom-medium third sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading" 
                      range-tzcld_profile.kind="${this.kinds}" 
                      widget-tzcld_profile.kind="solid-form-multipleselect-autocompletion-label" 
                      class-tzcld_profile.kind="segment margin-bottom-medium third sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading" 
                      range-tzcld_profile.step_state="${this.territoriesStepStates}" 
                      widget-tzcld_profile.step_state="solid-form-multipleselect-autocompletion-label" 
                      class-tzcld_profile.step_state="segment margin-bottom-medium third sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading" label-name="Nom du territoire" 
                      label-tzcld_profile.kind="Type de territoire" 
                      label-tzcld_profile.regions="Régions" 
                      label-tzcld_profile.step_state="Etat d'avancement" 
                      order-asc-tzcld_profile.regions="name" 
                      order-asc-tzcld_profile.kind="name" 
                      order-asc-tzcld_profile.step_state="name"
                      naked="">
                      </solid-form-search>
                      <solid-display 
                      solid-resource
                      loader-id="loader-${this.route}-my-communities"
                      data-src ="${this.myCommunities}"
                      next="${utils.TZCLD_URLS.my_territory_infos}"
      
                      class="segment full children children-quarter sm-children-full children-margin-bottom-medium sm-children-margin-bottom-xsmall children-padding-right-xsmall children-padding-left-xsmall sm-children-padding-none sm-whitespace-normal masonry pagination text-disable-selection" 
                      fields="segment1(segment2(logo), segment3(name, profile.shortDescription, counter))" 
                      filtered-by="my-communities-filter" 
                      order-by="name" 
                      paginate-by="20" 
                      class-segment1="segment hover bg-color-white shadow border-rounded-xxsmall full text-top whitespace-normal cursor-pointer" 
                      class-segment2="segment block padding-xlarge text-center" 
                      class-segment3="segment full padding-xlarge sm-padding-medium border-top border-color-grey text-center whitespace-normal" 
                      class-name="segment block one-line-ellipsis text-xlarge text-bold text-color-heading margin-bottom-xsmall" 
                      class-profile.shortdescription="segment two-lines-ellipsis margin-bottom-xlarge sm-margin-bottom-medium whitespace-normal circle-subtitle-custom" 
                      class-counter="segment block whitespace-normal" 
                      widget-logo="tzcld-communities-logo" 
                      action-counter="counter" 
                      widget-counter="tzcld-communities-counter-alternate" 
                      order-asc="name"
                      >
                      </solid-display>`;
      
                render += `
                  </div>
                </div>`;
                return render;
              }
              viewRightMenu(default_root) {
                let render = `
                <nav class="jsRightMenu segment sm-hidden text-disable-selection sidebar whitespace-normal" role="navigation">
                  <solid-router class="segment whitespace-normal text-color-heading text-bold" default-route="" >
                    <ul>
                      <li class="segment full sm-hidden padding-small text-normal jsOffsiteToggle">
                        <span class="icon icon-arrow-left icon-xsmall margin-left-xxsmall text-left"></span>
                        <span class="segment full text-right" hidden="">
                          <span class="icon icon-arrow-right icon-xsmall margin-right-xxsmall"></span>
                          <a data-trans="territory.menuRight.fold">Replier le menu</a>
                        </span>
                      </li>
                      <solid-route class="segment full" name="${utils.TZCLD_URLS.my_territory_infos}" use-id="">
                        <li class="segment full padding-medium">
                          <span class="tz2icon-ion_earth-outline icon-xlarge margin-right-medium"></span>
                          <a data-trans="territory.menuRight.presentation">Présentation</a>
                        </li>
                      </solid-route>
                      <solid-ac-checker permission="acl:Write" nested-field="tzcld_profile_identity" bind-resources>
                      <solid-route class="segment full" name="${utils.TZCLD_URLS.my_territory_auto_eval}" use-id="" >
                        <li class="segment full padding-medium">
                          <span class="tz2icon-carbon_chart-evaluation icon-xlarge margin-right-medium"></span>
                          <a data-trans="territory.menuRight.autoevaluation">Auto-évaluation</a>
                        </li>
                      </solid-route>
                      </solid-ac-checker>
                      <solid-ac-checker permission="acl:Write" nested-field="tzcld_community_synthesis_followed" bind-resources>
                      <solid-route class="segment full" name="${utils.TZCLD_URLS.my_territory_follow}" use-id="" >
                        <li class="segment full padding-medium">
                          <span class="tz2icon-info icon-xlarge margin-right-medium"></span>
                          <a data-trans="territory.menuRight.autoevaluation">Auto-évaluation</a>
                        </li>
                      </solid-route>
                      </solid-ac-checker>
                    </ul>
                  </solid-router>
                </nav>`;
                return render;
              }
      
              viewCommunityAnswers() {
      
      
                let render = `
                
                <solid-widget name="customtzcld-form-territory-project-team-memeber">
                  <template>
                    <solid-form
                    class="d-block rowClear form-hide-submit"
                    data-src="\${value}"
                    data-holder
                    partial
                    fields="segment1(firstname, name, etp, position_funding)"
                    class-segment1="segment full sm-full rowClear"
                    class-firstname="segment margin-bottom-medium quarter sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
                    class-name="segment margin-bottom-medium quarter sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading"
                    class-etp="segment margin-bottom-medium quarter sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading"
                    class-position_funding="segment margin-bottom-medium quarter sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading"
                    label-firstname="Nom * :"
                    label-name="Prénom * :"
                    required-firstname
                    required-name
                    label-etp="ETP consacrés au projet :"
                    label-position_funding="Financement du poste :"
                  ></solid-form>
                  </template>
              </solid-widget>
              <solid-widget name="customtzcld-form-territory-training">
                <template>
                  <solid-form
                  class="d-block rowClear form-hide-submit"
                  data-src="\${value}"
                  data-holder
                  partial
                  fields="segment1(training_course, training_promotoion, training_person)"
                  class-segment1="segment full sm-full rowClear"
                  class-training_course="segment margin-bottom-medium third sm-full padding-right-small sm-padding-none text-xlarge text-semibold text-color-heading"
                  class-training_promotoion="segment margin-bottom-medium third sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading"
                  class-training_person="segment margin-bottom-medium third sm-full padding-left-small sm-padding-none text-xlarge text-semibold text-color-heading"
                  label-training_course="Suivit du parcours Territoire * :"
                  label-training_promotoion="Numéro de promotion * :"
                  required-training_course
                  required-training_promotoion
                  label-training_person="Personne ayant suivit la formation :"
                  range-training_course="${this.territoriesTrainingCourses}"
                  range-training_promotoion="${this.territoriesTrainingPromotions}"
                  widget-training_course="solid-form-dropdown-label"
                  widget-training_promotoion="solid-form-dropdown-label"
                ></solid-form>
                </template>
            </solid-widget>
                    
                    <h2 class="margin-top-xxsmall margin-left-xsmall margin-bottom-medium sm-margin-none sm-margin-right-xsmall sm-margin-bottom-small sm-margin-left-xsmall text-xlarge text-bold text-color-heading text-uppercase">Auto-évaluation</h2>
      
                    <div class="segment full shadow bg-color-white margin-bottom-xlarge padding-xlarge sm-padding-none whitespace-normal">
                      <h2 class="margin-bottom-large margin-top-none margin-left-none text-xlarge text-xbold text-color-heading text-color-dark-blue">Carte d’identité du territoire</h2>
                      <div class="loader" id="loader-${this.route}-general-answer">
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                      </div>
                      
                      <solid-form 
              class="form" 
              bind-resources
              solid-resource
              partial
              autosave
              nested-field="tzcld_profile_identity"
              loader-id="loader-${this.route}-general-answer" 
              fields="segment(deputy, circonscription), segment1(origin_mobilization, application_date), territories_project_team_memebers_title, territories_project_team_memebers, territories_trainings_title, territories_trainings, reconnaissance_port_title, segment2(signatory_structure, birth_date, last_contribution_date), spacer" 
              label-segment="Général" 
              label-segment1="" 
              label-segment2="Portage de la demande de reconnaissance" 
              class-segment="segment full" 
              class-segment1="segment full"
              class-segment2="segment full"
      
              label-deputy="Député-e" 
              label-circonscription="Circonscription" 
              label-origin_mobilization="Origine de la mobilisation" 
              label-application_date="Date candidature estimée" 
              label-signatory_structure="Structure signataire de la charte" 
              label-birth_date="Date de naissance du projet" 
              label-last_contribution_date="Date dernier paiement de cotisation" 
      
              
              class-deputy="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
              class-circonscription="segment margin-bottom-medium half sm-full padding-left-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
              
              class-origin_mobilization="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
              class-application_date="segment margin-bottom-medium half sm-full padding-left-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
      
              class-signatory_structure="segment margin-bottom-medium third sm-full padding-right-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
              class-birth_date="segment margin-bottom-medium third sm-full padding-right-small padding-left-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
              class-last_contribution_date="segment margin-bottom-medium third sm-full padding-left-small sm-padding-none text-color-heading text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
      
              
              widget-origin_mobilization="solid-form-dropdown-label" 
              range-origin_mobilization=${this.territoriesOriginsMobilisation}" 

              
              widget-application_date="solid-form-date-label"
              widget-birth_date="solid-form-date-label"
              widget-last_contribution_date="solid-form-date-label"
      
               
              multiple-territories_project_team_memebers
              widget-territories_project_team_memebers="customtzcld-form-territory-project-team-memeber" 
              multiple-territories_project_team_memebers-add-label= "Ajouter une personne"
              multiple-territories_project_team_memebers-remove-label= "Supprimer"
              widget-territories_project_team_memebers_title="h3" 
              value-territories_project_team_memebers_title="Equipe projet"
      
              multiple-territories_trainings
              widget-territories_trainings="customtzcld-form-territory-training" 
              multiple-territories_trainings-add-label= "Ajouter une personne"
              multiple-territories_trainings-remove-label= "Supprimer"
              widget-territories_trainings_title="h3" 
              value-territories_trainings_title="Formation"
              
              widget-reconnaissance_port_title="h3" 
              value-reconnaissance_port_title="Portage de la demande de reconnaissance"
              
              class-spacer="segment third sm-hidden" 
              
              order-asc-tzcld_profile.step_state="name" 
              order-asc-tzcld_profile.kind="name" 
              order-asc-tzcld_profile.regions="name" 
              order-asc-tzcld_profile.departments="name" 
              
              widget-spacer="span">
            </solid-form>
      
                    </div>
                    <div class="segment block shadow bg-color-white margin-right-xxsmall margin-left-xxsmall sm-margin-none">
      
                      <div class="loader" id="loader-${this.route}-answer">
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                      </div>
      
                      <tzcld-autoeval 
                        class="tzcld-autoeval"
                        bind-resources=""
                        loader-id="loader-${this.route}-answer"
                        parts ="${this.parts}"
                        parts-points ="${this.partsPoints}"
                        point-answers ="${this.pointAnswers}"
                        api-url ="${this.apiUrl}"
                        solid-resource
                      `;
      
                  render += `>
                      </tzcld-autoeval>`;
                  
      
                render += `
                  </div>`;
                return render;
              }
              viewCommunityFollow() {
      
      
                let render = `
                    
                    <h2 class="margin-top-xxsmall margin-left-xsmall margin-bottom-medium sm-margin-none sm-margin-right-xsmall sm-margin-bottom-small sm-margin-left-xsmall text-xlarge text-bold text-color-heading text-uppercase">Auto-évaluation</h2>
      
                    <div class="segment full shadow bg-color-white margin-bottom-xlarge padding-xlarge sm-padding-none whitespace-normal">
                      <h2 class="margin-bottom-large margin-top-none margin-left-none text-xlarge text-xbold text-color-heading text-color-dark-blue">Synthèse</h2>
                      <div class="loader" id="loader-${this.route}-general-follow">
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                      </div>
                      
                      <solid-form 
                        class="form" 
                        bind-resources
                        solid-resource
                        partial
                        autosave
                        nested-field="tzcld_profile_identity"
                        loader-id="loader-${this.route}-general-follow" 
                        fields="segment(context, strongPoints), segment1(questions, needs), segment2(targetdate), spacer" 
                        
                        class-segment="segment full" 
                        class-segment1="segment full"
                        class-segment2="segment full"
                
                        label-context="Contexte" 
                        label-strongPoints="Points forts" 
                        label-questions="Interrogations / Risques / Difficultés" 
                        label-needs="Besoins d'accompagnement / Actions à suivre" 
                        label-targetdate="Date souhaité de dépôt de candidature"
                
                        
                        class-context="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
                        class-strongPoints="segment margin-bottom-medium half sm-full padding-left-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
                        
                        class-questions="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
                        class-needs="segment margin-bottom-medium half sm-full padding-left-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge" 
                
                        class-targetdate="segment margin-bottom-medium half sm-full padding-right-small sm-padding-none text-small text-semibold text-color-heading whitespace-normal text-xlarge"
                
                        widget-context="solid-form-textarea-label"
                        widget-strongPoints="solid-form-textarea-label"
                        widget-questions="solid-form-textarea-label"
                        widget-needs="solid-form-textarea-label"
                        widget-targetdate="solid-form-date-label"
                        
                        
                        class-spacer="segment third sm-hidden"
                        widget-spacer="span">
                      </solid-form>
                
                    </div>
                    <div class="segment block shadow bg-color-white margin-right-xxsmall margin-left-xxsmall sm-margin-none">
      
                      <div class="loader" id="loader-${this.route}-follow-answer">
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                      </div>
      
                      <tzcld-follow
                        class="tzcld-follow"
                        bind-resources=""
                        loader-id="loader-${this.route}-follow-answer"
                        parts ="${this.followParts}"
                        parts-points ="${this.followPartsPoints}"
                        point-answers ="${this.followPointAnswers}"
                        solid-resource
                      `;
      
                  render += `>
                      </tzcld-follow>`;
                  
      
                render += `
                  </div>`;
                return render;
              }
      
              template(props) {
                this.uniq = props.uniq || utils.uniq();
                this.parts = props.parts;
                this.partsPoints = props.partsPoints;
                this.pointAnswers = props.pointAnswers;
                this.followParts = props.followParts;
                this.followPartsPoints = props.followPartsPoints;
                this.followPointAnswers = props.followPointAnswers;
                this.communities = props.communities ;
                this.myCommunities = props.myCommunities ;
                this.territoriesTrainingCourses = props.territoriesTrainingCourses ;
                this.territoriesTrainingPromotions = props.territoriesTrainingPromotions ;
                this.regions = props.regions ;
                this.kinds = props.kinds ;
                this.territoriesStepStates = props.territoriesStapeStates ;
                this.territoriesOriginsMobilisation = props.territoriesOriginsMobilisationn ;
                this.apiUrl = props.apiUrl ;
      
                //console.table(props);
      
                this.route = this.getRoute(this.uniq);
      
                let render = `
                  ${this.routeurs()}
                  ${this.viewWidgets()}
                  ${this.viewMyCommunities()}
                  <div id="${utils.TZCLD_URLS.my_territory_space}" data-view="${utils.TZCLD_URLS.my_territory_space}" hidden>
                  
                    <div class="with-sidebar whitespace-normal jsMobileContentSidebarControl">
                      <div class="scrollbar-content views-container padding-top-xlarge sidebar-is-closed">
                      
                        <div id="${utils.TZCLD_URLS.my_territory_infos}" data-view="${utils.TZCLD_URLS.my_territory_infos}" class="community-my-community community-profile" hidden>
                        ${this.viewMyCommunity()}
                        </div>

                        <div id="${utils.TZCLD_URLS.my_territory_auto_eval}" data-view="${utils.TZCLD_URLS.my_territory_auto_eval}" class="community-answers" hidden>
                        ${this.viewCommunityAnswers()}
                        </div>

                        <div id="${utils.TZCLD_URLS.my_territory_follow}" data-view="${utils.TZCLD_URLS.my_territory_follow}" class="community-answers" hidden>
                        ${this.viewCommunityFollow()}
                        </div>
                    </div>

                      ${this.viewRightMenu()}

                    </div>`;
      
                return render;
              }
      
              _camelize(str) {
                return str.replace(/[-]+(.)/g, (match, chr) => chr.toUpperCase());
              }
      
              _uncamelize(str) {
                return str.replace(
                  /[A-Z]+/g,
                  (match, chr) => "-" + match.toLowerCase()
                );
              }
            }
          );



    });
});